/*
** CAUSA_DESCONEXION.C
**
** Textos explicativos para las causas
** de desconexion RADIUS.
**
**
** (c) 1.997-2.000 Jesus Cea Avion
** jcea@argo.es
** http://www.argo.es/~jcea/
** http://www.argo.es/~jcea/artic/radius02.htm
**
** Lea las condiciones de uso y distribucion
** en el fichero "COPYING".
**
**
** 07/Sep/99 Primera version de este fichero
*/

#include <stdlib.h>
#include "causa_desconexion.h"

/*
    $Id: causa_desconexion.c,v 1.5 2000/01/04 13:06:45 jcea Exp $
*/

char *causa_desconexion(char *causa, tipo_radius tipo)
{
  int c = atoi(causa);

  if (tipo == ASCEND)
    c += 1000;

  switch (c) {
  case 0:
  case 1000:

    if (*causa == '0')
      return ("--");            /* return("No hay conexiones previas"); */
    else
      return causa;
    break;

/* Desconexiones ASCEND */
  case 1010:
    return ("Portadora no detectada");
    break;
  case 1011:
  case 1185:
    return ("P&eacute;rdida de portadora");
    break;
  case 1021:
    return ("TimeOut por inactividad");
    break;
  case 1042:
    return ("Clave erronea o demasiadas sesiones");
    break;
  case 1020:
  case 1045:
    return ("Desconexi&oacute;n normal");
    break;
  case 1047:
    return ("Cierre LCP antes de abrir NCP's");
    break;
  case 1100:
    return ("Tiempo de conexi&oacute;n excedido");
    break;

/* Desconexiones estandar */
  case 1:
    return ("Desconexi&oacute;n normal");
    break;
  case 2:
    return ("P&eacute;rdida de portadora");
    break;
  case 3:
    return ("Sin Servicio");
    break;
  case 4:
    return ("TimeOut por inactividad");
    break;
  case 5:
    return ("Tiempo de conexi&oacute;n excedido");
    break;
  case 6:
    return ("Reset Administrativo");
    break;
  case 7:
    return ("Reinicio Administrativo");
    break;
  case 8:
    return ("Error de Puerto");
    break;
  case 9:
    return ("Error de NAS");
    break;
  case 10:
    return ("Solicitado por el NAS");
    break;
  case 11:
    return ("NAS Reiniciado");
    break;
  case 12:
    return ("Puerto no finalizado");
    break;
  case 13:
    return ("Puerto Preempted");
    break;
  case 14:
    return ("Puerto Suspendido");
    break;
  case 15:
    return ("Servicio No Disponible");
    break;
  case 16:
    return ("CallBack");
    break;
  case 17:
    return ("User Error");
    break;
  case 18:
    return ("Host Request");
    break;

  default:
    return ("Raz&oacute;n desconocida. "
            "<a href=mailto:ayuda@argo.es>" "Comunicar a ARGO</a>.");
    break;
  }
}
