/*
** FESTIVOS.C
**
** Proporciona informacion
** sobre festividades.
**
**
** (c) 1.997-2.000 Jesus Cea Avion
** jcea@argo.es
** http://www.argo.es/~jcea/
** http://www.argo.es/~jcea/artic/radius02.htm
**
** Lea las condiciones de uso y distribucion
** en el fichero "COPYING".
**
**
** 20/Oct/99 Primera version de este modulo.
*/

#include <string.h>
#include "festivos.h"
#include "tiempo.h"

#include "util.h"

/*
    $Id: festivos.c,v 1.6 2000/01/04 13:06:46 jcea Exp $
*/

static int todos_los_anos(char *mes, festivos_t * buf)
{
  int cont;

  for (cont = 0; cont < NUM_DIAS + 1; cont++)
    (*buf)[cont] = NULL;

  if (!strcmp(mes, "01")) {     /* Enero */
    (*buf)[1] = "Ano nuevo";
    return 1;
  }
  if (!strcmp(mes, "05")) {     /* Mayo */
    (*buf)[1] = "Dia del trabajo - Dia de la madre";
    return 1;
  }
  if (!strcmp(mes, "10")) {     /* Octubre */
    (*buf)[12] = "Dia del Pilar - Fuerzas Armadas - Hispanidad";
    return 1;
  }
  if (!strcmp(mes, "11")) {     /* Noviembre */
    (*buf)[1] = "Dia de todos los santos";
    return 1;
  }
  if (!strcmp(mes, "12")) {     /* Diciembre */
    (*buf)[6] = "Dia de la Constitucion";
    (*buf)[8] = "Dia de la Inmaculada";
    (*buf)[25] = "Navidad";
    return 3;
  }
  return 0;
}

static int ano1999(char *mes, festivos_t * buf)
{
  int c;

  c = todos_los_anos(mes, buf);
  if (!strcmp(mes, "01")) {     /* Enero */
    (*buf)[6] = "Dia de reyes"; /* No estoy muy seguro de ello... */
    c++;
  }
  if (!strcmp(mes, "04")) {     /* Abril */
    (*buf)[2] = "Viernes Santo";
    c++;
  }
  return c;
}

static int ano2000(char *mes, festivos_t * buf)
{
  int c;

  c = todos_los_anos(mes, buf);
  if (!strcmp(mes, "01")) {     /* Enero */
    (*buf)[6] = "Dia de reyes"; /* No estoy muy seguro de ello... */
    c++;
  }
  if (!strcmp(mes, "04")) {     /* Abril */
    (*buf)[21] = "Viernes Santo";
    c++;
  }
  if (!strcmp(mes, "08")) {     /* Agosto */
    (*buf)[15] = "La Asuncion  de la Virgen";
    c++;
  }
  return c;
}

int festivos(time_t tiempo, festivos_t * buf)
{
  char fecha[50];
  char mes[3];

  tiempo2str(fecha, tiempo);
  strncpy(mes, fecha + 4, 2);
  mes[2] = '\0';
  fecha[4] = '\0';
  if (!strcmp(fecha, "1999"))
    return ano1999(mes, buf);
  if (!strcmp(fecha, "2000"))
    return ano2000(mes, buf);
  return -1;
}
