/*
** PORTABLE.C
**
** Modulo de portabilidad.
**
**
** (c) 1.997-2.000 Jesus Cea Avion
** jcea@argo.es
** http://www.argo.es/~jcea/
** http://www.argo.es/~jcea/artic/radius02.htm
**
** Lea las condiciones de uso y distribucion
** en el fichero "COPYING".
**
**
** 07/Feb/00 Primera version de este fichero
*/

#include <stdio.h>

#include "portable.h"


/*
    $Id: portable.c,v 1.5 2000/02/07 21:15:15 jcea Exp $
*/

#ifdef EXISTS_LONG_LONG

char *tipo_int64_to_ascii(char *buf, tipo_int64 valor)
{
  sprintf(buf, "%lld", valor);
  return buf;
}

#else

/* Debe cumplir:
** - Multiplo de 10
** - Menor que 2^30
*/
#define MAX_LO (1000000000ul)

/*
** Las dos variables pueden ser la misma
*/
void suma_tipo_int64_2(tipo_int64 * a, tipo_int64 * b)
{
  a->hi += b->hi;
  a->lo += b->lo;

  if (a->lo >= MAX_LO) {
    a->lo -= MAX_LO;
    a->hi++;
  }
}

void tipo_int64_por_diez_2(tipo_int64 * a)
{
  tipo_int64 acc;

  suma_tipo_int64_2(a, a);      /* por 2 */
  assign_tipo_int64(acc, *a);
  suma_tipo_int64_2(&acc, &acc); /* por 4 */
  suma_tipo_int64_2(&acc, &acc); /* por 8 */
  suma_tipo_int64_2(a, &acc);   /* Completa la multiplicacion por 10 */
}

void multiply_tipo_int64_2(tipo_int64 * a, unsigned int b)
{
  tipo_int64 acc;

  assign_tipo_int64(acc, *a);
  clear_tipo_int64(*a);
  while (b) {
    if (b & 1) {
      suma_tipo_int64_2(a, &acc);
    }
    b >>= 1;
    suma_tipo_int64_2(&acc, &acc);
  }
}

int tipo_int64_es_cero_2(tipo_int64 * a)
{
  if ((a->hi == 0) && (a->lo == 0))
    return !0;
  return 0;
}

char *tipo_int64_to_ascii_2(char *buf, tipo_int64 * valor)
{
  int offset = 0;
  unsigned long v = MAX_LO / 10;
  unsigned long v2;

  if (!valor->hi) {
    sprintf(buf, "%lu", valor->lo);
    return buf;
  }
  sprintf(buf, "%ld", valor->hi);
  offset = strlen(buf);
  v2 = valor->lo;
  do {
    sprintf(buf + offset++, "%c", (char) ('0' + v2 / v));
    v2 %= v;
    v /= 10;
  } while (v);
  return buf;
}

#endif

void ascii_to_tipo_int64(unsigned char *cadena, tipo_int64 * valor)
{
  tipo_int64 v;

  clear_tipo_int64(*valor);
  while ((*cadena == ' ') || (*cadena == '\t'))
    cadena++;
  while ((*cadena >= '0') && (*cadena <= '9')) {
    tipo_int64_por_diez(*valor);
    int32_to_tipo_int64(v, (unsigned int) (*cadena - '0'));
    suma_tipo_int64(*valor, v);
    cadena++;
  }
}
