/*
** PORTABLE.H
**
** Modulo de portabilidad.
**
**
** (c) 1.997-2.000 Jesus Cea Avion
** jcea@argo.es
** http://www.argo.es/~jcea/
** http://www.argo.es/~jcea/artic/radius02.htm
**
** Lea las condiciones de uso y distribucion
** en el fichero "COPYING".
**
**
** 07/Feb/00 Primera version de este fichero
*/

#ifndef PORTABLE_H
#define PORTABLE_H

#include "config.h"


/*
    $Id: portable.h,v 1.5 2000/02/07 21:15:16 jcea Exp $
*/

#ifdef EXISTS_LONG_LONG
typedef long long tipo_int64;

#define clear_tipo_int64(a)     (a)=0
#define suma_tipo_int64(a,b)    (a)+=(b)
#define multiply_tipo_int64(a,b)  (a)*=(b)
#define assign_tipo_int64(a,b)   (a)=(b)
#define tipo_int64_por_diez(a)	(a)*=10
#define int32_to_tipo_int64(a,b)	(a)=(b)
#define tipo_int64_es_cero(a)	((a)==0)

char *tipo_int64_to_ascii(char *buf, tipo_int64 valor);

#else /* Nuestro compilador no sabe operar con tipos de 64 bits */

typedef struct {
  long hi;
  unsigned long lo;
} tipo_int64;

#define clear_tipo_int64(a)	(a).hi=(a).lo=0
#define suma_tipo_int64(a,b) suma_tipo_int64_2(&(a),&(b))
void suma_tipo_int64_2(tipo_int64 * a, tipo_int64 * b);
#define multiply_tipo_int64(a,b) multiply_tipo_int64_2(&(a),(b))
void multiply_tipo_int64_2(tipo_int64 * a, unsigned int b);
#define assign_tipo_int64(a,b)	(a).hi=(b).hi;(a).lo=(b).lo;
#define tipo_int64_por_diez(a) tipo_int64_por_diez_2(&(a))
void tipo_int64_por_diez_2(tipo_int64 * a);
#define int32_to_tipo_int64(a,b)	(a).hi=0;(a).lo=(b)
#define tipo_int64_es_cero(a) tipo_int64_es_cero_2(&(a))
int tipo_int64_es_cero_2(tipo_int64 * a);
#define tipo_int64_to_ascii(a,b) tipo_int64_to_ascii_2(a,&(b))
char *tipo_int64_to_ascii_2(char *buf, tipo_int64 * valor);
#endif

void ascii_to_tipo_int64(unsigned char *cadena, tipo_int64 * valor);

#endif
