/*
** WHOWAS.C
**
** Este programa lista los datos de los
** usuarios que estaban conectados en
** un momento determinado.
**
**
** (c) 1.997-2.000 Jesus Cea Avion
** jcea@argo.es
** http://www.argo.es/~jcea/
** http://www.argo.es/~jcea/artic/radius02.htm
**
** Lea las condiciones de uso y distribucion
** en el fichero "COPYING".
**
**
** 04/Ene/00 Version 1.0
**           Primera version de este modulo.
*/

#include <stdio.h>
#include <stdlib.h>
#include "conf.h"
#include "tiempo.h"
#include "version.h"
#include "called_id.h"

/*
    $Id: whowas.c,v 1.9 2000/02/10 11:23:33 jcea Exp $
*/

int main(int argc, char *argv[], char *env[])
{
  char buf1_int64[24], buf2_int64[24];
  log_estado estado;
  registro_log reg;
  int cont;
  char sesion_id[CAMPO_LONG];
  time_t tiempo, tiempo2, tiempo3;
  char *called_id;

  printf("%s", version_txt());

  tiempo = tiempo2 = str2tiempo(argv[1]);
  if (argc > 2)
    tiempo2 = str2tiempo(argv[2]);

  sesion_id[0] = '\0';
  for (cont = 0; accounting[cont].path != NULL; cont++) {
    accounting[cont].log->abre_log(accounting[cont].path, "");
    while (!0) {
      estado = accounting[cont].log->lee_registro(&reg);
      if (estado != LOG_OK)
        break;
      if ((reg.tipo != STOP) || (!strcmp(sesion_id, reg.sesion_id)) ||
          (reg.tiempo < tiempo) || (reg.tiempo - reg.duracion > tiempo2))
        continue;
      strcpy(sesion_id, reg.sesion_id);
      called_id = telefono2nombre(reg.called_id);
      if (called_id == NULL)
        called_id = "";
      tiempo3 = reg.tiempo - reg.duracion;
      printf("%s %s %s %s (%s) %s %ld %s %s\n",
             reg.nombre, reg.ip, reg.caller_id, reg.called_id, called_id,
             ctime(&tiempo3), reg.duracion,
             tipo_int64_to_ascii(buf1_int64, reg.bytes_tx),
             tipo_int64_to_ascii(buf2_int64, reg.bytes_rx));
    }
    accounting[cont].log->cierra_log();
  }
  return 0;
}
